%komunikace s uzivatelem, hlavni funkce

prvocislo :-
    write('Zadej cislo: '),
    read(N), N>1,
    seznamlichych(N,S),
    eratosthenes(N,S,Obraceny),
    obratit(Obraceny,[],Vysl),
    vypis(10,[2|Vysl]).

%vytvori seznam lichych cisel <= N
seznamlichych(N,S) :-
    sezn(3,N,S).

%vygeneruje seznam cisel H, H+2, H+4, ...N
sezn(N,N,[N]).
sezn(Velke,N,[]) :-
    Velke > N.
sezn(H,N,[H|T]) :-
    H<N,
    H1 is H+2,
    sezn(H1,N,T).

%vypisuje prvky seznamu, na kazdem radku Rad prvku
vypis(Rad,S) :-
    vypis(Rad,0,S).
vypis(_,_,[]) :- nl.
vypis(Rad,Rad,S) :-
    nl,
    vypis(Rad,0,S).
vypis(Rad,N,[H|T]) :-
    N<Rad,
    write(H), write(' '),
    N1 is N+1,
    vypis(Rad,N1,T).

%vezme seznam S a vsechna prvocisla z nej zaradi do E, klesajici
eratosthenes(N,S,E) :-
    sito(N,S,[],E).

%pomocny pro predchozi
sito(_,[],S,S).
sito(N,[H|T],S,P) :-
    H*H=<N,
    H1 is H+H,
    vyhod(H,H1,T,T1), !,
    sito(N,T1,[H|S],P).
sito(N,[H|T],S,P) :-
    H*H>N,
    obratit(T,[H|S],P).

%vyhod(C,P,S,V):
%vyhodi ze seznamu S cisla P+k*C pro k=0,1,2,...
vyhod(_,_,[],[]).
vyhod(C,P,[P|T],V) :-
    P1 is P+C,
    vyhod(C,P1,T,V).
vyhod(C,P,[H|T],V) :-
    P<H,
    P1 is P+C,
    vyhod(C,P1,[H|T],V).
vyhod(C,P,[H|T],[H|V]) :-
    P>H,
    vyhod(C,P,T,V).

%obratit(R,S,V): V bude zretezeni obraceneho seznamu R se seznamem S
obratit([],S,S).
obratit([H|T],S,V) :-
    obratit(T,[H|S],V).
