prvek(X,[X|_]).
prvek(X,[_|T]) :-
    prvek(X,T).

spoj(L1,L2,L) :-
    L1=[],
    L=L2.
spoj(L1,L2,L) :-
    L1=[H|T1],
    L=[H|T],
    spoj(T1,L2,T).

odstran(D,Lorig,Lvysl) :-
    Lorig=[D|T],
    Lvysl=T.
odstran(D,Lorig,Lvysl) :-
    Lorig=[H|T],
    Lvysl=[H|Tvysl],
    odstran(D,T,Tvysl).

odstran2(_,[],[]).
odstran2(D,[D|T],Lvysl) :-
    odstran2(D,T,Lvysl).
odstran2(D,[H|T1],[H|T2]) :-
    D\=H,
    odstran2(D,T1,T2).

odstran3(D,[D|T],T).
odstran3(D,[H|T1],[H|T2]) :-
    odstran3(D,T1,T2).

vloz(P,Seznam,[P|Seznam]).

podseznam([],_) :- !.
podseznam(S1,S2) :-
    spoj(Sp,_,S2),
    spoj(_,S1,Sp).

soucetkladnych([],0).
soucetkladnych([H|T],K) :-
    H=<0,
    soucetkladnych(T,K).
soucetkladnych([H|T],K) :-
    H>0,
    soucetkladnych(T,K1),
    K is K1+H.

bubblesort(Seznam,Vysledek) :-
    swap(Seznam,S1),!,
    bubblesort(S1,Vysledek).
bubblesort(Seznam,Seznam).
swap([X,Y|Zbytek],[Y,X|Zbytek]) :-
    X>Y.
swap([X|Zbytek],[X|Zbytek1]) :-
    swap(Zbytek,Zbytek1).


qsort([],[]).
qsort([H|T], Hotovo) :-
    rozdel(H,T,Mensi,Vetsi),
    qsort(Mensi,HM),
    qsort(Vetsi,HV),
    spoj(HM,[H|HV],Hotovo).

rozdel(_,[],[],[]).
rozdel(P,[H|T], [H|M], Vysledek) :-
    P>H, !,
    rozdel(P, T, M, Vysledek).
rozdel(P, [H|T], M, [H|Vysledek]) :-
    rozdel(P, T, M, Vysledek).

permutace([],[]).
permutace(L,[H|T]) :-
    odstran(H,L,L1),
    permutace(L1,T).


ocisluj(S) :-
    ocisluj(S,1).
ocisluj([],_) :-
    nl.
ocisluj([H|T],C) :-
    write(C),
    write('. '),
    write(H),
    nl,
    C1 is C+1,
    ocisluj(T,C1).

ocislujod(S,N) :-
    ocisluj(S,N).

delka([],0) :- !.
delka([_|T],N) :-
    delka(T,N1),
    N is N1+1.

nsd(X,_,_) :-
    X=<0,write('NSD nevypoctu.'),!,false.
nsd(_,X,_) :-
    X=<0,write('NSD nevypoctu.'),!,false.
nsd(P,P,P) :- !.
nsd(P1,P2,V) :-
    P1>P2,
    P is P1-P2,
    nsd(P,P2,V),!.
nsd(P1,P2,V) :-
    P1<P2,
    P is P2-P1,
    nsd(P1,P,V),!.


vypocet :-
    nacti(S),
    soucet(S).

nacti(S) :-
    repeat,
    write('Zadej cislo: '),
    read(X),
    append(S,[X]),
    atom(X),!.

soucet([X]) :-
    atom(X),
    write('Neni co scitat!'),!.
soucet([H|T]) :-
    nl,
    write(H),
    secti(T,H).

secti([X],Vysl) :-
    atom(X),
    write('='),
    write(Vysl),nl.
secti([H|T], Vysl) :-
    write('+'),
    write(H),
    secti(T,Vysl+H).

ityprvek([H|_],0,H) :-!.
ityprvek([_|T],N,P) :-
    N1 is N-1, ityprvek(T,N1,P).



